


HTListView.prototype.items;
HTListView.prototype.scrollArea;
HTListView.prototype.table;

HTListView.prototype.totalPages;
HTListView.prototype.currentPage;

HTListView.prototype.previousPageElement;
HTListView.prototype.nextPageElement;

HTListView.prototype.selector;
HTListView.prototype.delegate;

HTListView.prototype.showPrice = false;


function HTListView(scrollArea,table)//,previousPageElement,nextPageElement)
{

	var _self = this;

	this.scrollArea = scrollArea;
	this.table = table;
	
	/*
	this.previousPageElement = previousPageElement;
	
	
	
	this.previousPageElement.onclick = function (event) 
	{
		
		_self.showPreviousPage(event);
		
	};

	
	this.nextPageElement = nextPageElement;
	
	this.nextPageElement.onclick = function (event)
	{
		
		_self.showNextPage(event);
		
	};
	*/
	
	document.onkeypress = function (event) 
	{
		
		_self.keyPressed(event);
		
	};
	
	
	
}


HTListView.prototype.setDelegate = function (delegate)
{
	this.delegate = delegate;
	
}

HTListView.prototype.setShowPrice = function(show)
{
	this.showPrice = show;
}



HTListView.prototype.setOnSelection = function(selector)
{
	this.selector = selector;
} 


HTListView.prototype._removeAll = function()
{
	while (this.table.hasChildNodes())
		this.table.removeChild(this.table.firstChild);
}

HTListView.prototype._addRow = function(item)
{
	var li = "tr";//"li";
	var ul = "td";//"ul";

	var row = document.createElement(li);
	
	
	var _self = this;
	var _item = item;
	row.onclick = function()
	{
		
		_self._selectedRow(event,_item);
	};
	
	row.setAttribute ("tag", item['title']);
	row.setAttribute ("id", item['asin']);
		
	var cell = document.createElement (ul);
	
	cell.setAttribute("id","listRow");
	
	cell.appendChild (document.createTextNode(item['title']));
	row.appendChild (cell);
	
	
	
	if(this.showPrice)
	{
		//var priceRow = document.createElement(li);
		//priceRow.setAttribute("tag",item['price'])
		
		
		var priceCell = document.createElement(ul);
		priceCell.setAttribute("id","listRow");
		priceCell.appendChild(document.createTextNode(item['price']));
		
		row.appendChild(priceCell);
		
	
	}
	
	//row.style.width = "100%";
	
	this.table.appendChild(row);

	
	
	return row;
}

HTListView.prototype._selectedRow = function(event,item)
{

	this.setSelectedItem(item);
	
	
	//alert('selected row. ' + item['title']);
	try
	{
		
		this.selector(item);
	}
	catch(err)
	{
	
	}
	
}

HTListView.prototype.set = function(items)//,page,total)
{
	this.items = items;
	//this.currentPage = page;
	//this.totalPages = total;

	//this.updatePageElements();
	
	
	
	var table = this.table;
	this._removeAll();	
	
	if(items == null)
	{
		alert("no items.");
		return;
	}
	
	for (var i=0; i<items.length; ++i)	
	{
		var item = items[i];
		this._addRow(item);
	}
	
	this._unselectAll();
	
	
	this.scrollArea.object.refresh();
	
	this.selectionDidChange();
	
	//this.scrollArea.object.reveal(this.table);
	
	
	
	
}




HTListView.prototype.keyPressed = function(event) 
{
	if(event == null)
		return;
		
	//var keyID = (window.event) ? event.keyCode : e.keyCode;
	
	switch (event.keyIdentifier)
	{
		
		case "Up":
			this.selectPreviousItem();
			break;
		case "Down":
			this.selectNextItem();
			break;
		case "U+001B": //ESC
			this.unselectAll();
			break;
		default:
			handled = false;
	}



}

HTListView.prototype.setSelectedIndex = function(index)
{
	if(index != -1)
	{
		
		this.table.children[index].setAttribute("class", "selectedItem");
		
	
		//this.scrollArea.object.reveal(this.table);
		//var scrollArea = document.getElementById("scrollArea").object;
		
		//scrollArea.reveal(document.getElementById("itemList").children[index]);
	
		this.selectionDidChange();
	
	}

}

HTListView.prototype.setSelectedItem = function(item)
{
	var rows = this.table.children;
	for(var i=0; i<rows.length; i++)
	{
		var child = rows[i];
		if(child.id == item["asin"])
		{
			this._unselectAll();
			this._selectRow(i);
			
			this.selectionDidChange();
			//return child;
			return;
		}
		
		
	}
	
	alert("asin: " + item['asin'] + " not found. selection not changed.");

}

HTListView.prototype.getSelectedItem = function()
{

	var rows = this.table.children;
	for(var i=0; i<rows.length; i++)
	{
		var child = rows[i];
		if(child.className == "selectedItem")
		{
			return this.items[i];
			//return child;
		}
		
		
	}
	
	

}

HTListView.prototype.getSelectedIndex = function()
{

	var rows = this.table.children;
	for(var i=0; i<rows.length; i++)
	{
		var child = rows[i];
		if(child.className == "selectedItem")
		{
			return i;
		}
		
		
	}
	
	return -1;

}

HTListView.prototype.numberOfSelectionItems = function()
{
	return this.table.children.length;
}



HTListView.prototype.selectPreviousItem = function() 
{
	var selectedIndex = this.getSelectedIndex();
	if(selectedIndex != 0)
	{
		this._unselectRow(selectedIndex);
		selectedIndex--;
		this.setSelectedIndex(selectedIndex);
		//this.selectRow(selectedIndex);
	}

}

HTListView.prototype.selectNextItem = function() 
{

	var selectedIndex = this.getSelectedIndex();
	
	if((selectedIndex+1) < this.numberOfSelectionItems())
	{
		this._unselectRow(selectedIndex);
		selectedIndex++;
		this.setSelectedIndex(selectedIndex);
		//this.selectRow(selectedIndex);
	}
}


HTListView.prototype.unselectAll = function()
{
	
	this._unselectAll();
	
	this.selectionDidChange();
	
}


HTListView.prototype._unselectAll = function() 
{
	var rows = this.table.children;
	for(var i=0; i<rows.length; i++)
	{
		this._unselectRow(i);
	}

	
	
}

HTListView.prototype._selectRow = function(index) 
{
	if(index != -1)
	{

		this.table.children[index].setAttribute("class", "selectedItem");
		
	
		//var scrollArea = document.getElementById("scrollArea").object;
		
		
		
		this.scrollArea.object.reveal(this.table.children[index]);
		//scrollArea.reveal(document.getElementById("itemList").children[index]);
	
	
		
	}
}

HTListView.prototype._unselectRow = function(index)
{
	
	try
	{
		this.table.children[index].setAttribute("class", "item");
	}
	catch(err)
	{
		alert(err);
	}
	
}

/*delgate methods*/


HTListView.prototype.selectionDidChange = function()
{

	try
	{
		this.delegate.selectionDidChange(this,this.getSelectedItem());
	
	}
	catch(err)
	{
		alert("delegate: " + this.delegate);
		alert("err: " + err);
	}

}


/*end of delegate methods*/

