

ItemListSelectionController.prototype.animationDuration = 250;
ItemListSelectionController.prototype.animationInterval = 25;

ItemListSelectionController.prototype.categoryAnimationDuration = 250;
ItemListSelectionController.prototype.categoryAnimationInterval = 50;

ItemListSelectionController.prototype.expandAnimator;
ItemListSelectionController.prototype.collapseAnimator;

ItemListSelectionController.prototype.cartHeight = 21;
ItemListSelectionController.prototype.cartHeightWithoutBorder = 17;

ItemListSelectionController.prototype.categoryHeight = 22;

ItemListSelectionController.prototype.listStartingTop = 96;

ItemListSelectionController.prototype.hideCartAfterCollapse = false;
ItemListSelectionController.prototype.hideCategoryAfterCollapse = false;

ItemListSelectionController.prototype.currentSearch;

ItemListSelectionController.prototype.lastSelectedItem;

ItemListSelectionController.prototype.reselectOnLoad = null;

ItemListSelectionController.prototype.clearingCart = false;

function ItemListSelectionController(listView,displayArea,itemView)
{

	this.listView = listView;
	this.displayArea = displayArea;
	this.itemView = itemView;
	
	//works -- still shifts up and down.
	//this.startingRect = new AppleRect(0, 0, 440, 520);
	//this.finishingRect = new AppleRect(0, 0, 440, 330);
	
	var original = getElementSize($("frontImg"));
	
	var displayAreaSize = getElementSize(displayArea);
	
	var expandedHeight = original['height']+displayAreaSize['height'];
	
	this.expandedRect = new AppleRect(0, 0, original['width'], expandedHeight);
	this.collapsedRect = new AppleRect(0, 0, original['width'], original['height']);
	
	
	this.cartButton = document.getElementById("cartAddButton");
	this.cartRemoveButton = document.getElementById("cartRemoveButton");
	this.checkoutButton = document.getElementById("checkoutButton");
	this.clearCartButton = document.getElementById("clearCartButton");
	this.cartInfoArea = document.getElementById("cartInfo");
	this.cartTotalAmount = document.getElementById("cartTotalAmountText");
	
	this.hideCartAfterCollapse = false;
	this.showingSingleItemArea = false;
	
	var _self = this;
	this.cartButton.onclick = function(event)
	{
		_self.addSelectedItemToCart(event);
	}
	this.cartRemoveButton.onclick = function(event)
	{
		_self.removeSelectedItemFromCart(event);
	}
	
	
	this.checkoutButton.onclick = function(event)
	{
		_self.checkout(event);
	}
	
	this.clearCartButton.onclick = function(event)
	{
        
		_self.clearCart(event);
	}

}

ItemListSelectionController.prototype.getCart = function()
{
	if(this.cart == null)
	{
		this.cart = new AmazonCart(selectedCountry,selectedType);
		this.cart.setDelegate(this);
		var _self = this;
		this.cart.onLoad = function(cart)
		{
			_self.cartModified();
		};
		
	}
	
	return this.cart;

}

ItemListSelectionController.prototype.setPreviousPageElement = function(element)
{
	var _self = this;
	this.previousPageElement = element;
	this.previousPageElement.onclick = function (event) 
	{
		
		_self.showPreviousPage(event);
		
	};

}

ItemListSelectionController.prototype.setNextPageElement = function(element)	
{

	var _self = this;
	this.nextPageElement = element;	
	this.nextPageElement.onclick = function (event)
	{
		
		_self.showNextPage(event);
		
	};
	
}

ItemListSelectionController.prototype.showPreviousPage = function(event)
{
	if(this.currentSearch == this.getCart())
	{
		alert("carts don't have pages fool.");
		return;
	}
	if(this.currentPage > 1)
	{
		this.currentPage--;
		this.currentSearch.setCurrentPage(this.currentPage);
		this.currentSearch.loadItemList();
	}
	else
		alert("i can't do that.");
}

ItemListSelectionController.prototype.showNextPage = function(event)
{
	if(this.currentSearch == this.getCart())
	{
		alert("carts don't have pages fool.");
		return;
	}

	if(this.currentPage < this.totalPages)
	{
		this.currentPage++;
			this.currentSearch.setCurrentPage(this.currentPage);
		this.currentSearch.loadItemList();
	}
	else
		alert("i can't do that.");
		
		
		
}



ItemListSelectionController.prototype.addSelectedItemToCart = function(event)
{
	
	var item = this.listView.getSelectedItem();
	
	this.getCart().addItem(item);
	

	
	
}

ItemListSelectionController.prototype.removeSelectedItemFromCart = function(event)
{
		var item = this.listView.getSelectedItem();
	
	
		this.getCart().removeItem(item);
	
    

	
	
}

ItemListSelectionController.prototype.clearCart = function(event)
{
	this.reselectOnLoad = null;
	
	this.getCart().clear();
    
    clearCart();
	
	
}	

ItemListSelectionController.prototype.cartModified = function(event)
{
	

	if(this.cart.cartExists() && this.cart.getItems().length != 0 )
	{
		//ElementUtils.show(this.cartInfoArea);
		this.showCartInfoArea();
		//this.cartTotalAmount = "$1 brazillian";
		
		if(currentNavButton.id == "cart")
		{
			//in order to remove an item when the cart is selected, we had to have been selecting the cart. so just reshow it.
			this.showCart();
			return;
		}
		
	}
	else
	{
		
		
		
		if(currentNavButton.id == "cart")
		{	
		
			if(!this.showingSingleItemArea)
			{
				//alert("hide cart now.");
				this.hideCartInfoArea();
			}
			else
			{
               // alert("hide cart after collapse.");
				this.hideCartAfterCollapse = true;
			}
			var cartButton = document.getElementById("cart");
			currentNavButton = document.getElementById("movies");
			changeSelectedNavButton(cartButton,currentNavButton);
			
			
			
		}
		else
		{
           // alert("hide cart now.");
			this.hideCartInfoArea();
		}
	}
	
	this.updateAmazonButtons();
	
}





ItemListSelectionController.prototype.checkout = function(event)
{

	var url = this.getCart().cartCheckoutURL();
	if(window.widget)
	{
		widget.openURL(url);
	}
	
}

ItemListSelectionController.prototype.updateAmazonButtons = function(item)
{
	//alert("update buttons");
	
	var item = this.listView.getSelectedItem();
    if(item == null)
        return;
	
	var cart = this.getCart();
	if(cart.cartExists())
	{
		
		this.cartTotalAmount.innerHTML = cart.getTotal();
		
       
		
		var items = cart.getItems();
		for(var i=0; i<items.length; i++)
		{
			
            
			if(item['asin'] == items[i]['asin'])
			{
				ElementUtils.hide(this.cartButton);
				ElementUtils.show(this.cartRemoveButton);
	
				
				return;
				
			}
		}
		
		
	}
		
	ElementUtils.hide(this.cartRemoveButton);
	ElementUtils.show(this.cartButton);
				

	
}



ItemListSelectionController.prototype.needAmazonUsername = function(event)
{
	ElementUtils.show(document.getElementById("amazonUsernameRequired"));
	showBack();
	document.getElementById("amazonUsernameTextfield").focus();

	

}

ItemListSelectionController.prototype._currentSize = function()
{
	var original = getElementSize($("frontImg"));
	
	//alert("currentSize(" + original['width'] + "," + original['height'] + ")");
	
	return new AppleRect(0, 0, original['width'], original['height']);

}

ItemListSelectionController.prototype.getSelection = function()
{
	return this.lastSelectedItem;
}

ItemListSelectionController.prototype.selectionDidChange = function(table,item)
{
    
	if(item == null)
	{
      
		//alert("(HIDE) display value: " + this.displayArea.style.display);
		this.hideSingleItemArea();
	}
	else
	{
		
        
		var amazonItem = new AmazonItem(item['asin'],selectedCountry());
		
		this.lastSelectedItem = amazonItem;
		
		amazonItem.setDelegate(this);
		amazonItem.loadItem();
		this.updateAmazonButtons(item);
	}
}

//AmazonItem delegate method
ItemListSelectionController.prototype.itemDidLoad = function(amazonItem)
{
	//alert("display value: " + this.displayArea.style.display);

	this.showSingleItemArea(amazonItem);
	//this.itemView.setItem(amazonItem);
	

}

ItemListSelectionController.prototype._displayItem = function(item)
{
	this.itemView.setItem(item);
}


ItemListSelectionController.prototype.showCartInfoArea = function(item)
{
	var itemArea = this.cartInfoArea;
	
	if(itemArea.style.display == 'none')
	{
		var expandAnimator = new AppleAnimator (this.animationDuration, this.animationInterval);
		
		//AppleRect(left, top, right, bottom)
		var current = this._currentSize();
		
		
		
		var biggerSize = new AppleRect(0,0,current.right,current.bottom+this.cartHeight);//35);
		
		this.collapsedRect.bottom += this.cartHeightWithoutBorder;// 35;
		this.expandedRect.bottom += this.cartHeight;//35;
		
		var currentExpandAnimation = new AppleRectAnimation( this._currentSize(),biggerSize, this.rectResizeHandler );
		var currentNavBarAnimation = new AppleAnimation(37, 25.0, this.navAnimationHandler);
		
		
		expandAnimator.addAnimation(currentExpandAnimation);
		expandAnimator.addAnimation(currentNavBarAnimation);
		
		
		expandAnimator.oncomplete = function()
		{
			ElementUtils.show(itemArea);
			ElementUtils.show(document.getElementById("cart"));
		}
		
		expandAnimator.start();
	}

}

ItemListSelectionController.prototype.hideCartInfoArea = function(item)
{
   
    
	var itemArea = this.cartInfoArea;
	
	if(itemArea.style.display == 'block')
	{
		
		ElementUtils.hide(itemArea);
		ElementUtils.hide(document.getElementById("cart"));
		
		var collapseAnimator = new AppleAnimator (this.animationDuration, this.animationInterval);
		
		
		var smallerSize = new AppleRect(0,0,this._currentSize().right,this._currentSize().bottom-this.cartHeight);//35);
		
		this.collapsedRect.bottom -= this.cartHeightWithoutBorder;//35;
		this.expandedRect.bottom -= this.cartHeight;//35;
		
		//alert("smaller size: " + smallerSize);
		//alert("current: " + this._currentSize());
		
		var currentCollapseAnimation = new AppleRectAnimation( this._currentSize(),smallerSize, this.rectResizeHandler );
		var currentNavBarAnimation = new AppleAnimation(25.0, 37.0, this.navAnimationHandler);
		
		
		collapseAnimator.addAnimation(currentCollapseAnimation);
		collapseAnimator.addAnimation(currentNavBarAnimation);
	
		collapseAnimator.oncomplete = function()
		{
			
		}
	
		collapseAnimator.start();
	}
}

ItemListSelectionController.prototype.showSingleItemArea = function(item)
{
	var itemArea = this.displayArea;
  
	if (this.expandAnimator == null && 
		(itemArea.style.display == 'none' || this.collapseAnimator != null) )
	{
		
		if(this.collapseAnimator != null)
		{
			this.collapseAnimator.stop();
			this.collapseAnimator = null;
		}

		this.expandAnimator = new AppleAnimator (this.animationDuration, this.animationInterval);
		
		

		
		
		var currentExpandAnimation = new AppleRectAnimation( this._currentSize(),this.expandedRect, this.rectResizeHandler );
		this.expandAnimator.addAnimation(currentExpandAnimation);
		
		var _self = this;
		
		this.expandAnimator.oncomplete = function()
		{
			_self._displayItem(item);
			ElementUtils.show(itemArea);
			
			_self.expandAnimator = null;
			_self.showingSingleItemArea = true;
			
		}
		
		this.expandAnimator.start();

	} 
	else
		this._displayItem(item);

	
	
}

ItemListSelectionController.prototype.hideSingleItemArea = function(item)
{

   
	var itemArea = this.displayArea;

	if (this.collapseAnimator == null && 
		(itemArea.style.display != 'none' || this.expandAnimator != null) )
	{
		
		
		ElementUtils.hide(itemArea);
		
		if(this.expandAnimator != null)
		{
			this.expandAnimator.stop();
			this.expandAnimator = null;
		}
	
		this.collapseAnimator = new AppleAnimator (this.animationDuration, this.animationInterval);

		

		var currentCollapseAnimation = new AppleRectAnimation( this._currentSize(), this.collapsedRect,  this.rectResizeHandler );
		this.collapseAnimator.addAnimation(currentCollapseAnimation);
		
		var _self = this;
		this.collapseAnimator.oncomplete = function()
		{
			_self.collapseAnimator = null;
			
			if(_self.hideCartAfterCollapse)
			{
				_self.hideCartInfoArea();
				_self.hideCartAfterCollapse = false;
			}
			if(_self.hideCategoryAfterCollapse)
			{
				_self.hideCategoryArea();
				_self.hideCategoryAfterCollapse = false;
			}
		
			
				_self.showingSingleItemArea = false;

		}
		
		this.collapseAnimator.start();
		
	} 
	

}

ItemListSelectionController.prototype.showCategoryArea = function()
{
	//ElementUtils.show($("category"));
	
	var itemArea = $("category");
	
	if(itemArea.style.display == 'none')
	{
		var expandAnimator = new AppleAnimator (this.categoryAnimationDuration, this.categoryAnimationInterval);
		
		
		var current = this._currentSize();
		
		
			
		var biggerSize = new AppleRect(0,0,current.right,current.bottom+this.categoryHeight);
		
		this.collapsedRect.bottom += this.categoryHeight;
		this.expandedRect.bottom += this.categoryHeight;
		
		
		this.displayArea.style.top = 300 + this.categoryHeight + "px";
		
		//alert("cart: " + this.cartInfoArea.style.top);
		
		var top = this.listStartingTop;
		
		var currentExpandAnimation = new AppleRectAnimation( this._currentSize(),biggerSize, this.rectResizeHandler );
		var currentAreaBarAnimation = new AppleAnimation(top, (top + this.categoryHeight), this.listAnimationHandler);
		
		
		expandAnimator.addAnimation(currentExpandAnimation);
		expandAnimator.addAnimation(currentAreaBarAnimation);
		
		
		expandAnimator.oncomplete = function()
		{
			ElementUtils.show(itemArea);
			
		}
		
		expandAnimator.start();
	}

	
	
}

ItemListSelectionController.prototype.hideCategoryArea = function()
{
	//ElementUtils.hide($("category"));
	
	var itemArea = $("category");
	
	if(itemArea.style.display == 'block')
	{
		
	
		ElementUtils.hide(itemArea);
		var expandAnimator = new AppleAnimator (this.categoryAnimationDuration, this.categoryAnimationInterval);
		
	
		var current = this._currentSize();
		
		var biggerSize = new AppleRect(0,0,current.right,current.bottom-this.categoryHeight);
		
		this.collapsedRect.bottom -= this.categoryHeight;
		this.expandedRect.bottom -= this.categoryHeight;
		
		this.displayArea.style.top = 300 + "px";
		
		
		var top = this.listStartingTop;
		
		var currentExpandAnimation = new AppleRectAnimation( this._currentSize(),biggerSize, this.rectResizeHandler );
		//var currentAreaBarAnimation = new AppleAnimation(110, (110 - this.categoryHeight), this.listAnimationHandler);
		var currentAreaBarAnimation = new AppleAnimation((top + this.categoryHeight), top, this.listAnimationHandler);
		
		
		expandAnimator.addAnimation(currentExpandAnimation);
		expandAnimator.addAnimation(currentAreaBarAnimation);
		
		
		expandAnimator.oncomplete = function()
		{
			//ElementUtils.show(itemArea);
			
		}
		
		expandAnimator.start();
	}


	

}

ItemListSelectionController.prototype.navAnimationHandler = function(animation, current, start, finish)
{

	var navbar = document.getElementById("navbar");
	navbar.style.left = current + "px";

}

ItemListSelectionController.prototype.listAnimationHandler = function(animation, current, start, finish)
{

	var area = document.getElementById("list");
	area.style.top = current + "px";

}


ItemListSelectionController.prototype.rectResizeHandler = function( rectAnimation, currentRect, startingRect, finishingRect )
{
	WidgetUtils.resizeTo(currentRect.right, currentRect.bottom);
}


ItemListSelectionController.prototype.amazonSearch = function(event)
{
	
	document.getElementById("itemListLabel").innerHTML = "Search:";
    var terms = null;
    if(event == null)
        terms = $("searchfield").value;
    else
        terms = event.srcElement.value;
	if(terms == null || terms == "")
	{
		this.defaultSearch(event);
		return;
	}
	
	var node = categoryPopup.object.select.value;
	
	this.currentSearch = new AmazonSearch(terms,selectedType(),selectedCountry());
	this.currentSearch.setDelegate(this);
	this.currentSearch.setSubCategory(node);
	this.currentSearch.loadItemList();
	
}

ItemListSelectionController.prototype.cateogrySelected = function(event)
{

	var categoryPopup = document.getElementById("categoryPopup");
	
	
	setSelectedCategory(categoryPopup.object.getSelectedIndex());
	
   
    this.defaultSearchForSelectedCategory();
}



ItemListSelectionController.prototype.childNodesDidLoad = function(browseNode)
{

	this._setupCategoryForChildren(browseNode.getChildNodes());
	
	this.defaultSearchForSelectedCategory();


}

ItemListSelectionController.prototype._setupCategoryForChildren = function(children)
{
	var categoryPopup = document.getElementById("categoryPopup");
	
	removeAllChildren(categoryPopup.object.select);
	
	
	for(var i=0; i<children.length; i++)
	{
		var child = children[i];
		
		var option = document.createElement("option");
		
		option.setAttribute ("value", child['id']);
		option.innerHTML = child['name'];
		
		categoryPopup.object.select.appendChild(option);
	}
	
	categoryPopup.object.setSelectedIndex(selectedCateogry());
}




ItemListSelectionController.prototype.defaultSearch = function(event)
{
    
   
    this.reselectOnLoad = this.listView.getSelectedItem();
    
	
	this.showCategoryArea();
	
//	if(defaultSearch() == "NewReleases")
//		document.getElementById("itemListLabel").innerHTML = "Recent Releases:";
//	else
//		document.getElementById("itemListLabel").innerHTML = "Most Popular:";
	var search = new AmazonBrowseNode(selectedType(),selectedCountry(),defaultSearch());//"TopSellers");
	//var search = new AmazonBrowseNode(selectedType(),selectedCountry(),"NewReleases");
	search.setDelegate(this);
	
	if(search.getChildNodes() == null)
	{
		search.loadSubnodes();
	}
	else
	{
		
		this.defaultSearchForSelectedCategory();
	}
	//search.loadSubnodes();
	
}

ItemListSelectionController.prototype.defaultSearchForSelectedCategory = function(event)
{
	
    if($("searchfield").value.length != 0)
    {
       // alert("not default. search.");
        //we really need to do a user search. 
        this.amazonSearch();
        return;
    }
    
    
    this.reselectOnLoad = this.listView.getSelectedItem();
     
	this.currentPage = 1;
	this.listView._removeAll();
	
	this.listView.setShowPrice(false);
	
	if(defaultSearch() == "NewReleases")
		document.getElementById("itemListLabel").innerHTML = "Recent Releases / Coming Soon:";
	else
		document.getElementById("itemListLabel").innerHTML = "Most Popular:";
	this.currentSearch = new AmazonBrowseNode(selectedType(),selectedCountry(),defaultSearch(),this.currentPage);//"TopSellers");
	//var search = new AmazonBrowseNode(selectedType(),selectedCountry(),"NewReleases");
	this.currentSearch.setDelegate(this);
	
	var node = categoryPopup.object.select.value;

	this.currentSearch.setSubCategory(node);
	this.currentSearch.loadItemList();
	
}


ItemListSelectionController.prototype.wishlistSearch = function(event)
{

    this.reselectOnLoad = this.listView.getSelectedItem();

	this.currentPage = 1;
	if(this.listView.getSelectedItem() == null)
	{
	   this.hideCategoryArea();
	}
	else
		this.hideCategoryAfterCollapse = true;
		
	this.listView._removeAll();
   
   this.listView.setShowPrice(false);

   
	document.getElementById("itemListLabel").innerHTML = "Wishlist:";
   
	var wishlist = new AmazonWishlist(amazonUsername(),selectedCountry(),this.currentPage);
	wishlist.setDelegate(this);
	wishlist.loadItemList();
	
}

ItemListSelectionController.prototype.showCart = function(event)
{
  
    this.reselectOnLoad = this.listView.getSelectedItem();
	
	if(this.listView.getSelectedItem() == null)
	{
	   this.hideCategoryArea();
	}
	else
		this.hideCategoryAfterCollapse = true;

	this.listView._removeAll();
	
	this.listView.setShowPrice(true);
	
	document.getElementById("itemListLabel").innerHTML = "Cart:";
   
	var search = this.getCart();
	this.currentSearch = this.getCart();
	
	this._updatePageSelection(search);
	
	this.listView.set(search.getItems(),search.getCurrentPage(),search.getTotalPages());
    
    if(this.reselectOnLoad != null)
    {
       // alert("selected on load: " + this.reselectOnLoad['asin']);
        selectionTable.setSelectedItem(this.reselectOnLoad);
    }
    this.reselectOnLoad = null;

}

ItemListSelectionController.prototype._updatePageSelection = function(search)
{
	if(search.getCurrentPage() == null)
		this.currentPage = 1;
	else
		this.currentPage = search.getCurrentPage();
	if(search.getTotalPages() == null)
		this.totalPages = 1;
	else
		this.totalPages = search.getTotalPages();
	
	if(this.totalPages == 1)
	{
		ElementUtils.hide(this.previousPageElement);
		ElementUtils.hide(this.nextPageElement);
		ElementUtils.hide($("pageInfo"));
	}	
	else
	{
	
		ElementUtils.show(this.previousPageElement);
		ElementUtils.show(this.nextPageElement);
		ElementUtils.show($("pageInfo"));
		
		var previousClass = "enabledPageButton";
		var nextClass = "enabledPageButton";
		
		if(this.currentPage == 1)
			previousClass = "disabledPageButton";
		if(this.currentPage == this.totalPages)
			nextClass = "disabledPageButton";
			
		this.previousPageElement.setAttribute("class",previousClass);
		this.nextPageElement.setAttribute("class",nextClass);
		$("pageInfo").innerHTML = this.currentPage + " of " + this.totalPages;

	}
	

		
	
}

ItemListSelectionController.prototype.searchDidFinish = function(search)
{	

	//alert("search did finish. " + search.getItems().length + " current: " + search.getCurrentPage());

	this._updatePageSelection(search);
	
	
	this.listView.set(search.getItems(),search.getCurrentPage(),search.getTotalPages());
	
   if(this.reselectOnLoad != null)
   {
       // alert("selected on load: " + this.reselectOnLoad['asin']);
        selectionTable.setSelectedItem(this.reselectOnLoad);
        
        //a kludge since the collapse isn't allowed to finish and so the cart is never hidden. this handles the cartModified function's expections.
        if(this.hideCartAfterCollapse)
            this.hideCartInfoArea()
		
    }
    this.reselectOnLoad = null;
	
	
    
	


}

